﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Common;
using System.Threading;
using Timer = System.Windows.Forms.Timer;

namespace ReadyQueueDemo
{
	public partial class Form1 : Form
	{
		Func<Form1, bool> RunTest = form => Tests.FifoReadyQueue.Test( form );

		protected static Form1 Instance { get; set; }

		public static void RegisterThread( int index, string name ) { Instance.List.RegisterThread( index, name ); }
		public static void ClearList() { Instance.List.Clear(); }
		public static void Add( string text ) { Instance.List.Add( text ); }

		public ConcurrentList List { get { return list; } }

		Timer _KickStart = null;

		public Form1()
		{
			Instance = this;

			InitializeComponent();
		}

		private void Form1_Load( object sender, EventArgs e )
		{
			_KickStart = new Timer { Interval = 1 }; 
			_KickStart.Tick += KickStart;
			_KickStart.Start();
		}

		void KickStart( object sender, EventArgs args )
		{
			_KickStart.Dispose();
			_KickStart = null;

			if ( !RunTest( this ) ) Close();
		}

		// Msg event
		public class MsgEventArgs : EventArgs { public Message Message; }
		public static event EventHandler<MsgEventArgs> Msg = delegate { };
		MsgEventArgs _MessageEventArgs = new MsgEventArgs();

		protected override void WndProc( ref Message m )
		{
			_MessageEventArgs.Message = m;
			Msg( this, _MessageEventArgs );

			base.WndProc( ref m );
		}
	}
}
