﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using Common;

namespace ReadyQueueDemo.Tests
{
	class FifoReadyQueue
	{
		static FifoReadyQueue()
		{
			Form1.Msg += ( s, a ) => { if ( a.Message.Msg == UM.FifoReadyQueue ) Form1.Add( "pumped message" ); };
			//Form1.Msg += ( s, a ) => { if ( a.Message.Msg == UM.FifoReadyQueue ) throw new ApplicationException( "goodbye, world" ); };
		}

		internal static bool Test( Form1 form )
		{
			Form1.ClearList();
			Form1.RegisterThread( 0, "Main Thread" );
			Form1.Add( "BEGIN" );
			Form1.Add( "*** FifoReadyQueue.Test ***" );
			Thread.Sleep( 1000 );

			var handle = form.Handle;
			var key = new object();

			// Control thread
			new Thread( o =>
			{
				Form1.RegisterThread( 1, "Worker Thread" );

				Form1.Add( "blocking" );
				lock ( key )
				{
					Form1.Add( "acquired" );
					Thread.Sleep( 3000 );
					Form1.Add( "sending message" );
					User32.SendMessage( handle, UM.FifoReadyQueue, 0, 0 );
					Thread.Sleep( 1000 );
					Form1.Add( "releasing" );
				}
			} ).Start();

			// Lucky thread
			new Thread( o =>
			{
				Form1.RegisterThread( 2, "Lucky Thread" );

				Thread.Sleep( 2000 );
				Form1.Add( "blocking" );
				lock ( key )
				{
					Form1.Add( "acquired" );
					Thread.Sleep( 1000 );
					Form1.Add( "releasing" );
				}
			} ).Start();

			// Main thread
			Thread.Sleep( 1000 );
			Form1.Add( "blocking" );
			lock ( key )
			{
				Form1.Add( "acquired" );
				Thread.Sleep( 1000 );
				Form1.Add( "releasing" );
			}

			Form1.Add( "*** FifoReadyQueue.Test ***" );
			Form1.Add( "END" );

			return true;
		}
	}
}
